Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/SelfTest/src/test.cpp	(revision 101)
@@ -99,7 +99,9 @@
   ALLOC1_SC_SIGNAL( in_EVENT_DEPTH                        ," in_EVENT_DEPTH                        ",Tdepth_t           ,_param->_nb_context);
 
+  ALLOC1_SC_SIGNAL(out_DEPTH_VAL                          ,"out_DEPTH_VAL                          ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_CURRENT                      ,"out_DEPTH_CURRENT                      ",Tdepth_t           ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_MIN                          ,"out_DEPTH_MIN                          ",Tdepth_t           ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_MAX                          ,"out_DEPTH_MAX                          ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL(out_DEPTH_FULL                         ,"out_DEPTH_FULL                         ",Tcontrol_t         ,_param->_nb_context);
   
   /********************************************************
@@ -170,6 +172,8 @@
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_DEPTH_CURRENT                      ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_DEPTH_MIN                          ,_param->_nb_context);
-    }
   INSTANCE1_SC_SIGNAL(_Prediction_unit,out_DEPTH_MAX                          ,_param->_nb_context);
+    }
+  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_DEPTH_VAL                          ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Prediction_unit,out_DEPTH_FULL                         ,_param->_nb_context);
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -372,7 +376,9 @@
   DELETE1_SC_SIGNAL( in_EVENT_DEPTH                    ,_param->_nb_context);
 
+  DELETE1_SC_SIGNAL(out_DEPTH_VAL          ,_param->_nb_context);
   DELETE1_SC_SIGNAL(out_DEPTH_CURRENT      ,_param->_nb_context);
   DELETE1_SC_SIGNAL(out_DEPTH_MIN          ,_param->_nb_context);
   DELETE1_SC_SIGNAL(out_DEPTH_MAX          ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_DEPTH_FULL         ,_param->_nb_context);
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/SelfTest/src/test.cpp	(revision 101)
@@ -143,7 +143,9 @@
   ALLOC1_SC_SIGNAL( in_EVENT_DEPTH                    ," in_EVENT_DEPTH                    ",Tdepth_t           ,_param->_nb_context);
 
+  ALLOC1_SC_SIGNAL(out_DEPTH_VAL                      ,"out_DEPTH_VAL                      ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_CURRENT                  ,"out_DEPTH_CURRENT                  ",Tdepth_t           ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_MIN                      ,"out_DEPTH_MIN                      ",Tdepth_t           ,_param->_nb_context);
   ALLOC1_SC_SIGNAL(out_DEPTH_MAX                      ,"out_DEPTH_MAX                      ",Tdepth_t           ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL(out_DEPTH_FULL                     ,"out_DEPTH_FULL                     ",Tcontrol_t         ,_param->_nb_context);
   
   /********************************************************
@@ -239,6 +241,8 @@
   INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_CURRENT                  ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_MIN                      ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_MAX                      ,_param->_nb_context);
     }
-  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_MAX                      ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_VAL                      ,_param->_nb_context);
+  INSTANCE1_SC_SIGNAL(_Update_Prediction_Table,out_DEPTH_FULL                     ,_param->_nb_context);
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
@@ -373,7 +377,8 @@
 		  
 		  if (_param->_have_port_depth)
+                    {
 		  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		      
+                    }
 		  SC_START(0); // fct melay
 		  
@@ -404,6 +409,8 @@
 	    
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -462,6 +469,8 @@
 	      
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
             }
         }
@@ -490,6 +499,8 @@
 
                   if (_param->_have_port_depth)
+                    {
                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                    }
 		  
 		  SC_START(0);
@@ -516,6 +527,8 @@
 	      
               if (_param->_have_port_depth)
+                {
               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -539,6 +552,8 @@
 
 //                   if (_param->_have_port_depth)
+//                     {
 //                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
 //                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+//                     }
 		  
 		  SC_START(0);
@@ -654,7 +669,8 @@
 		  
 		  if (_param->_have_port_depth)
+                    {
 		  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		      
+                    } 
 		  SC_START(0); // fct melay
 		  
@@ -685,6 +701,8 @@
 	    
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -764,6 +782,8 @@
 	      
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
             }
         }
@@ -793,7 +813,8 @@
 
                   if (_param->_have_port_depth)
+                    {
                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		  
+                    }
 		  SC_START(0);
 		  
@@ -819,6 +840,8 @@
 	      
               if (_param->_have_port_depth)
+                {
               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -1013,7 +1036,8 @@
 		  
 		  if (_param->_have_port_depth)
+                    {
 		  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		      
+                    } 
 		  SC_START(0); // fct melay
 		  
@@ -1044,6 +1068,8 @@
 	    
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -1123,6 +1149,8 @@
 	      
               if (_param->_have_port_depth)
+                {
 	      TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
             }
         }
@@ -1152,7 +1180,8 @@
 
                   if (_param->_have_port_depth)
+                    {
                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		  
+                    }		  
 		  SC_START(0);
 		  
@@ -1178,6 +1207,8 @@
 	      
               if (_param->_have_port_depth)
+                {
               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
 	}
@@ -1450,7 +1481,8 @@
                     
                     if (_param->_have_port_depth)
+                      {
                     TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                     TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-                    
+                      }
                     SC_START(0); // fct melay
                     
@@ -1481,6 +1513,8 @@
                 
                 if (_param->_have_port_depth)
-                  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+                  {
+                TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                 TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                  }
               }
           }
@@ -1541,6 +1575,8 @@
                 
                 if (_param->_have_port_depth)
-                  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+                  {
+                TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                 TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                  }
               }
           }
@@ -1593,7 +1629,8 @@
                     
                     if (_param->_have_port_depth)
+                      {
                     TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                     TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-                    
+                      }
                     SC_START(0); // fct melay
                     
@@ -1624,6 +1661,8 @@
                 
                 if (_param->_have_port_depth)
-                  TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
+                  {
+                TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                 TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                  }
               }
           }
@@ -1677,7 +1716,9 @@
 
                   if (_param->_have_port_depth)
+                    {
                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		  
+                    }
+
 		  SC_START(0);
 		  
@@ -1711,6 +1752,8 @@
 	      
               if (_param->_have_port_depth)
+                {
               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
           }
@@ -1738,7 +1781,8 @@
 
                   if (_param->_have_port_depth)
+                    {
                   TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
                   TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
-		  
+                    }
 		  SC_START(0);
 		  
@@ -1772,6 +1816,8 @@
 	      
               if (_param->_have_port_depth)
+                {
               TEST(Tdepth_t,out_DEPTH_MIN [context]->read(), upt_bottom [context]);
               TEST(Tdepth_t,out_DEPTH_MAX [context]->read(), upt_top [context]);
+                }
 	    }
           }
@@ -2176,7 +2222,9 @@
 
   // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  delete [] out_DEPTH_VAL;
   delete [] out_DEPTH_CURRENT;
   delete [] out_DEPTH_MIN;
   delete [] out_DEPTH_MAX;
+  delete [] out_DEPTH_FULL;
 
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Types.h	(revision 101)
@@ -26,5 +26,5 @@
       EVENT_STATE_FLUSH_UPT             , // in commit stage, detect a miss, context is stop and ufpt is flush, update RAS
       EVENT_STATE_UPDATE_CONTEXT        , // prediction unit is update, send signal to context manager
-      EVENT_STATE_WAIT_END_EVENT          // prediction unit is ok, wait the end of envent (send by Context State)
+      EVENT_STATE_WAIT_END_EVENT          // prediction unit is ok, wait the end of event (send by Context State)
     } event_state_t;
 
@@ -45,4 +45,5 @@
       UPDATE_PREDICTION_STATE_EVENT             , // previous branch is a miss prediction
       UPDATE_PREDICTION_STATE_END_OK            , // branch is updated,       update pointer
+      UPDATE_PREDICTION_STATE_END_KO_WAIT_END   , // branch is updated, don't update pointer
       UPDATE_PREDICTION_STATE_END_KO              // branch is updated, don't update pointer
     } upt_state_t;
@@ -147,4 +148,5 @@
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_EVENT      : return "event"     ; break;
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_END_OK     : return "end_ok"    ; break;
+      case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_END_KO_WAIT_END: return "end_ko_wait_end"    ; break;
       case morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::update_prediction_table::UPDATE_PREDICTION_STATE_END_KO     : return "end_ko"    ; break;
       default    : return ""      ; break;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h	(revision 101)
@@ -148,7 +148,9 @@
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t         )  ** out_DEPTH_VAL                      ; //[nb_context] 
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_CURRENT                  ; //[nb_context] 
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MIN                      ; //[nb_context]
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MAX                      ; //[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_DEPTH_FULL                     ; //[nb_context]
     // If DEPTH_CURRENT :
     // equal at     DEPTH_MIN            -> not speculative
@@ -172,4 +174,5 @@
   private   : uint32_t                      * reg_UPT_TOP_EVENT                  ; //[nb_context]
   private   : uint32_t                      * reg_UPT_UPDATE                     ; //[nb_context]
+  private   : bool                          * reg_UPT_EMPTY                      ; //[nb_context]
                                                                                               
   private   : bool                          * reg_IS_ACCURATE                    ; //[nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 101)
@@ -160,7 +160,9 @@
     {
       ALLOC1_INTERFACE("depth",OUT,SOUTH, "depth", _param->_nb_context);
-      ALLOC1_SIGNAL_OUT(out_DEPTH_CURRENT,"CURRENT",Tdepth_t,_param->_size_depth);
-      ALLOC1_SIGNAL_OUT(out_DEPTH_MIN    ,"MIN"    ,Tdepth_t,_param->_size_depth);
-      ALLOC1_SIGNAL_OUT(out_DEPTH_MAX    ,"MAX"    ,Tdepth_t,_param->_size_depth+1);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_VAL    ,"VAL"    ,Tcontrol_t,1);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_CURRENT,"CURRENT",Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_MIN    ,"MIN"    ,Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_MAX    ,"MAX"    ,Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_FULL   ,"FULL"   ,Tcontrol_t,1);
     }
 
@@ -201,4 +203,5 @@
     ALLOC1(reg_UPT_TOP_EVENT                ,uint32_t     ,_param->_nb_context);
     ALLOC1(reg_UPT_UPDATE                   ,uint32_t     ,_param->_nb_context);
+    ALLOC1(reg_UPT_EMPTY                    ,bool         ,_param->_nb_context);
 
     ALLOC1(reg_EVENT_STATE                  ,event_state_t,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 101)
@@ -117,7 +117,9 @@
 
 	// ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+        DELETE1_SIGNAL(out_DEPTH_VAL          ,_param->_nb_context,1);
         DELETE1_SIGNAL(out_DEPTH_CURRENT      ,_param->_nb_context,_param->_size_depth);
         DELETE1_SIGNAL(out_DEPTH_MIN          ,_param->_nb_context,_param->_size_depth);
-        DELETE1_SIGNAL(out_DEPTH_MAX          ,_param->_nb_context,_param->_size_depth+1);
+        DELETE1_SIGNAL(out_DEPTH_MAX          ,_param->_nb_context,_param->_size_depth);
+        DELETE1_SIGNAL(out_DEPTH_FULL         ,_param->_nb_context,1);
 
         // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -154,4 +156,5 @@
         DELETE1(reg_UPT_TOP_EVENT                ,_param->_nb_context);
         DELETE1(reg_UPT_UPDATE                   ,_param->_nb_context);
+        DELETE1(reg_UPT_EMPTY                    ,_param->_nb_context);
         
         DELETE1(reg_EVENT_STATE                  ,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 101)
@@ -34,10 +34,21 @@
     for (uint32_t i=0; i<_param->_nb_context; i++)
       {
+        // is a valid instruction ?
+        // If DEPTH_CURRENT :
+        // equal at     DEPTH_MIN            -> not speculative
+        // not include ]DEPTH_MIN:DEPTH_MAX] -> previous branch miss
+        //     include ]DEPTH_MIN:DEPTH_MAX] -> speculative
+
+        PORT_WRITE(out_DEPTH_VAL     [i],(reg_UPDATE_PREDICTION_TABLE [i][reg_UPT_TOP [i]]._state == UPDATE_PREDICTION_STATE_EMPTY));
 	if (_param->_have_port_depth)
           {
         PORT_WRITE(out_DEPTH_CURRENT [i], reg_UPT_TOP    [i]);
         PORT_WRITE(out_DEPTH_MIN     [i], reg_UPT_BOTTOM [i]);
-          }
 	PORT_WRITE(out_DEPTH_MAX     [i], reg_UPT_TOP    [i]);
+          }
+	PORT_WRITE(out_DEPTH_FULL    [i], not reg_UPT_EMPTY [i] and (reg_UPT_TOP [i] == reg_UPT_BOTTOM [i]));
+
+//         bool empty = reg_UPT_EMPTY [i];
+// 	PORT_WRITE(out_DEPTH_MAX     [i], ((empty)?reg_UPT_BOTTOM [i]:((reg_UPT_TOP [i]==0)?(_param->_size_upt_queue[i]-1):(reg_UPT_TOP [i]-1))));
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 101)
@@ -46,4 +46,5 @@
             reg_UPT_TOP_EVENT        [i] = 0;
             reg_UPT_UPDATE           [i] = 0;
+            reg_UPT_EMPTY            [i] = true;
                                                                                     
             reg_IS_ACCURATE          [i] = true;
@@ -87,9 +88,13 @@
             // UPDATE_PREDICTION_TABLE
             {
-              uint32_t bottom = reg_UPT_BOTTOM [i];
-              bool     end_ok = (reg_UPDATE_PREDICTION_TABLE [i][bottom]._state == UPDATE_PREDICTION_STATE_END_OK);
-              bool     end_ko = (reg_UPDATE_PREDICTION_TABLE [i][bottom]._state == UPDATE_PREDICTION_STATE_END_KO);
+              uint32_t      bottom      = reg_UPT_BOTTOM [i];
+              bool          end_ok      = (reg_UPDATE_PREDICTION_TABLE [i][bottom]._state == UPDATE_PREDICTION_STATE_END_OK);
+              bool          end_ko      = (reg_UPDATE_PREDICTION_TABLE [i][bottom]._state == UPDATE_PREDICTION_STATE_END_KO);
+//               event_state_t event_state = reg_EVENT_STATE [i];
 
               // Test if state is end
+//               if ((end_ok or end_ko) and 
+//                   ((event_state != EVENT_STATE_UPDATE_CONTEXT) and
+//                    (event_state != EVENT_STATE_WAIT_END_EVENT)))
               if (end_ok or end_ko)
                 {
@@ -102,4 +107,8 @@
                   // Update pointer
                   reg_UPT_BOTTOM [i] = (bottom+1)%_param->_size_upt_queue[i];
+
+                  if (reg_UPT_BOTTOM [i] == reg_UPT_TOP [i])
+                    reg_UPT_EMPTY [i] = true; // free a slot
+
 //                   if (bottom = reg_UPT_UPDATE [i])
 //                     reg_UPT_UPDATE [i] = reg_UPT_BOTTOM [i];
@@ -108,4 +117,7 @@
                       reg_UPT_TOP    [i] = reg_UPT_TOP_EVENT [i];
                       reg_UPT_UPDATE [i] = reg_UPT_TOP_EVENT [i];
+
+                      if (reg_UPT_BOTTOM [i] != reg_UPT_TOP [i])
+                        reg_UPT_EMPTY [i] = false;
                     }
                 }
@@ -290,4 +302,5 @@
               // Update pointer
               reg_UPT_TOP     [context] = (upt_ptr_write+1)%_param->_size_upt_queue [context];
+              reg_UPT_EMPTY   [context] = false;
 //            reg_UPT_UPDATE  [context] = reg_UPT_TOP [context];
 	    }
@@ -338,4 +351,7 @@
                   reg_UPT_TOP_EVENT [context] = top;
 
+                  if (reg_UPT_BOTTOM [context] == reg_UPT_TOP [context])
+                    reg_UPT_EMPTY [i] = true;
+
 #ifdef DEBUG_TEST
                   if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state != UPDATE_PREDICTION_STATE_WAIT_END)
@@ -483,4 +499,9 @@
                       if (ko)
                         {
+                          // Ko : wait end of all instruction
+//                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_KO_WAIT_END (update)",context,depth);
+                          
+//                           reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END_KO_WAIT_END;
+
                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_KO (update)",context,depth);
                           
@@ -535,5 +556,5 @@
                       
                       // Free the branch with no accurate ?
-                      if (reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false)
+                      if ( (reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false) and not ko)
                         reg_IS_ACCURATE [context] = true;
                     }
@@ -587,5 +608,6 @@
 //            Tdepth_t       depth       = PORT_READ(in_EVENT_DEPTH [i]);
             
-              // Test if end of miss
+              // Test if end of miss -> all previous branch is complete
+              //                     -> all next     branch is finish
               if (event_type  == EVENT_TYPE_MISS_SPECULATION)
                 {
@@ -602,4 +624,19 @@
                   
                   reg_EVENT_STATE [i] = EVENT_STATE_OK;
+                  reg_IS_ACCURATE [i] = true;
+
+//                   Tdepth_t depth = reg_UPT_TOP [i];
+
+#ifdef DEBUG_TEST
+//                   if (reg_UPDATE_PREDICTION_TABLE [i][depth]._state != UPDATE_PREDICTION_STATE_END_KO_WAIT_END)
+//                     throw ERRORMORPHEO(FUNCTION,_("Event : invalid upt event state."));
+//                   if (reg_UPDATE_PREDICTION_TABLE [i][depth]._state != UPDATE_PREDICTION_STATE_END_KO)
+//                     throw ERRORMORPHEO(FUNCTION,_("Event : invalid upt event state."));
+#endif
+                  
+//                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_KO (update)",i,depth);
+                          
+//                   reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_END_KO;
+
                 }
             }
@@ -699,4 +736,5 @@
 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP_EVENT       : %d",reg_UPT_TOP_EVENT      [i]);
 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE          : %d",reg_UPT_UPDATE         [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_EMPTY           : %d",reg_UPT_EMPTY          [i]);
 	for (uint32_t j=0; j<_param->_size_upt_queue[i]; j++)
 	  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"        [%d] %.4d, %.8x %.8x, %.1d %.1d %.1d, %.8d %.8x %.4d - %s",
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h	(revision 101)
@@ -121,7 +121,9 @@
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	      
+  public    : SC_OUT(Tcontrol_t         )  ** out_DEPTH_VAL                           ; //[nb_context]
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_CURRENT                       ; //[nb_context]
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MIN                           ; //[nb_context]
   public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MAX                           ; //[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_DEPTH_FULL                          ; //[nb_context]
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_allocation.cpp	(revision 100)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_allocation.cpp	(revision 101)
@@ -127,7 +127,9 @@
       ALLOC1_INTERFACE("depth",OUT,SOUTH,"Interface with depth",_param->_nb_context);
 
-      ALLOC1_SIGNAL_OUT(out_DEPTH_CURRENT      ,"current"      ,Tdepth_t,_param->_size_depth);
-      ALLOC1_SIGNAL_OUT(out_DEPTH_MIN          ,"min"          ,Tdepth_t,_param->_size_depth);
-      ALLOC1_SIGNAL_OUT(out_DEPTH_MAX          ,"max"          ,Tdepth_t,_param->_size_depth+1);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_VAL          ,"val"          ,Tcontrol_t,1);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_CURRENT      ,"current"      ,Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_MIN          ,"min"          ,Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_MAX          ,"max"          ,Tdepth_t  ,_param->_size_depth);
+      ALLOC1_SIGNAL_OUT(out_DEPTH_FULL         ,"full"         ,Tcontrol_t,1);
     }
 
@@ -729,4 +731,8 @@
 #endif
 	  
+	  PORT_MAP(_component,src ,"out_DEPTH_"+toString(i)+"_VAL",
+                              dest,"out_DEPTH_"+toString(i)+"_VAL");
+	  PORT_MAP(_component,src ,"out_DEPTH_"+toString(i)+"_FULL",
+                              dest,"out_DEPTH_"+toString(i)+"_FULL");
 	  if (_param->_have_port_depth)
             {
@@ -735,7 +741,7 @@
 	  PORT_MAP(_component,src ,"out_DEPTH_"+toString(i)+"_MIN",
                               dest,"out_DEPTH_"+toString(i)+"_MIN");
-            }
 	  PORT_MAP(_component,src ,"out_DEPTH_"+toString(i)+"_MAX",
                               dest,"out_DEPTH_"+toString(i)+"_MAX");
+            }
 	}
 
